/* eslint-disable @typescript-eslint/naming-convention */
import fs from "fs";
import { GenericDbField } from "../../../db/model/GenericDbField";
import * as vscode from "vscode";
import { GenericDbTable } from "../../../db/model/GenericDbTable";
import { AbstractTypeScriptLoopbackProcessor } from "./AbstractTypeScriptLoopbackProcessor";
import { GenericDbTypeField } from "../../../db/model/GenericDbTypeField";
import { EnumDbType } from "../../../db/model/EnumDbType";
import { GenericDbFKey } from "../../../db/model/GenericDbFKey";
import { GeneratorTool } from "../../../tools/GeneratorTool";
import { ExtraField } from "../../../model/ExtraField";

export class TypescriptLoopbackModelProcessor extends AbstractTypeScriptLoopbackProcessor {
  // This processor can handle AI
  protected canUseAI?: boolean | undefined = false;

  getProcessorFolder(): string {
    return "models";
  }

  getProcessorName(): string {
    return "loopback_model";
  }

  async process(): Promise<void> {
    await this.defaultProcess();
  }

  protected async processTable(rTable: GenericDbTable): Promise<void> {
    if (rTable?.fields && rTable.fields.length > 0) {
      // Load templates
      var tpl = fs.readFileSync(this.getTemplateBasePath() + "tpl_loopback_model_ts", "utf8");

      // Class name
      var className = this.processClassNameFromTable(rTable.tableName);

      // Extrafield for imports
      var extraFields = new ExtraField();

      var fieldsToInject = "";
      let primaryindex = 0;
      for (const fielddata of rTable.fields) {
        if (fielddata.fieldName !== undefined && fielddata.fieldName !== "") {
          let fieldName = this.getFieldName(fielddata.fieldName);
          if (fieldName !== undefined && fieldName !== "") {
            // Get all foreign key columns related to this field
            const fKeysFromField = (fielddata.isFKey) ? GeneratorTool.getAllFKeyFromField(fielddata, rTable.fKeys) : undefined;
            // If field is a foreign key and is single field for foreign key, had a belongsTo
            // Loopback doesn't know how to handle composite foreign keys :(
            if (fKeysFromField !== undefined && fKeysFromField.length === 1) {
                fieldsToInject += this.getBelongsToField(fielddata, fKeysFromField[0], extraFields);
            } else {
              var fieldType = this.converter.fieldConvertToType(fielddata.type);
              var nullable = this.getOptionalChar(fielddata);
              let indexPrim = fielddata.isPKey ? ++primaryindex : undefined;
              let annotField = this.getFieldAnnotation(fielddata, indexPrim);
  
              fieldsToInject += "\n\n" + annotField + "\n\t" + fieldName + nullable + " : " + fieldType?.targetType + ";";  
            }
          }
        }
      }

      const modelTemplate = {
        schema: this.db.getSchema(),
        table: rTable.tableName,
        className: className,
        fields: fieldsToInject,
        extraFields_import: extraFields.getImportsTxt(),
      };

      // Careful, for loopback file names, there is no "_" we must put some "-" instead
      const fileNameForLoopback = this.convertFilenameForLoopback(rTable.tableName.toLowerCase());

      // Complete index.ts file if needed
      this.updateIndexImport(this.getOutProcessorPath(), `${fileNameForLoopback}.model`);

      await this.writeTemplateToFile({
        rFilePath: `${this.getOutProcessorPath()}${fileNameForLoopback}.model.ts`,
        rTemplate: tpl,
        rFieldsTemplate: modelTemplate,
        rFields: rTable?.fields,
      });
    }
  }

  getFieldAnnotation(rField: GenericDbField, rNum: number | undefined): string {
    if (rField?.fieldName && rField.type?.type) {
      let type = this.converter.fieldConvertToType(rField.type);
      let sqltype = this.converter.fieldConvertToSql(rField.type);
      let id = rNum;
      let scale;
      let precision: string | undefined = "";
      let dataLength: number | undefined = rField.type.length;
      let dataPrecision;
      let dataScale;
      let generated;
      let databaseType = this.getLoopbackDatabaseType(rField.type);

      if (rField.isAutogenerated) {
        generated = true;
      }

      switch (type?.targetType) {
        case "number":
          scale = 0;
          dataScale = 0;
          precision = dataLength && dataLength > 0 ? dataLength.toString() : undefined;
          dataPrecision = precision;
          dataLength = undefined;
          break;
      }

      // Check if field is 'really' required
      // Note that if field is nullable or is in protected fields array, we set this field as optional on json 
      const required = !rField.isNullable && !this.PROTECTED_FIELDS.includes(rField.fieldName) && !generated;

      let txt =
        "" +
        `\t@property({\n` +
        `\t\ttype: '${databaseType ?? type?.targetType}',\n` +
        `\t\trequired: ${required},\n` +        
        `${(!required) ? "\t\tjsonSchema: {nullable: true},\n" : ""}` + // Field can be ommitted if nullable
        `${generated ? "\t\tgenerated: " + generated + ",\n" : ""}` +
        `${precision ? "\t\tprecision: " + precision + ",\n" : ""}` +
        `${scale ? "\t\tscale: " + scale + ",\n" : ""}` +
        `${id ? "\t\tid: " + id + ",\n" : ""}` +
        `\t\tmysql: {\n` +
        `\t\t\tcolumnName: '${rField.fieldName}',\n` +
        `\t\t\tdataType: '${sqltype}',\n` +
        `\t\t\tdataLength: ${dataLength ?? "null"},\n` +
        `\t\t\tdataPrecision: ${dataPrecision ?? "null"},\n` +
        `\t\t\tdataScale: ${dataScale ?? "null"},\n` +
        `\t\t\tnullable: '${rField.isNullable ? "Y" : "N"}',\n` +
        `\t\t},\n` +
        `\t})`;

      return txt;
    } else {
      vscode.window.showWarningMessage("No Field or Field type");
      return "";
    }
  }

  /**
   * Generate a belongsTo field
   * @param rField : Field for belongsTo
   * @param rFKeysFromField : Foreign key column
   * @param rExtraFields : Extrafields to add extra imports
   * @returns 
   */
  private getBelongsToField(rField: GenericDbField, rFKeysFromField: GenericDbFKey, rExtraFields: ExtraField): string {
    let txt = "";
    const fKey = rFKeysFromField;              
    if (fKey?.referencedTable) {
      let type = this.converter.fieldConvertToType(rField.type);
      let className = this.processClassNameFromTable(fKey.referencedTable);
      txt += "\n\n\t";
      txt += `\n\t@belongsTo(() => ${className}, {name: '${fKey.referencedTable}'})`;
      txt += `\n\t${fKey.columnName}: ${type?.targetType};`;
      // Add import for rExtraFields
      const fileNameForLoopback = this.convertFilenameForLoopback(fKey.referencedTable.toLowerCase());
      rExtraFields.addImport(this.getImportFrom(`{${className}} from './${fileNameForLoopback}.model'`));
    }
    return txt;
  }

  /**
   * Get loopback database type for model
   * @param rFieldType : field type in database
   * @returns loopback database type
   */
  private getLoopbackDatabaseType(rFieldType: GenericDbTypeField): string | undefined {
    switch (rFieldType?.type) {
      case EnumDbType.date:
      case EnumDbType.datetime:
      case EnumDbType.timestamp:
        return "date";
      default:
        return undefined;
    }
  }
}
